/*
  
  paps - passively active ports scanner
  _-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-
  
  (C) Copyright 2006 by willdamn <willdamn@gmail.com>
  
*/

#include "global.h"

#define COMP(a,b) ((a) > (b) ? (b) : (a))

struct pthread_arg *arg;

int main(int argc, char **argv)
{
  elem_t *temp;
  pthread_t pthread_id[PTHREAD_MAX];
  struct hostent *hostinfo;
  char *gateway_ip = NULL;
  char *ptr, *main_part, *port_range;
  long target;
  int *scan_type, tab[4] = { FIN_SCAN, XMAS_SCAN, NULL_SCAN, SYN_SCAN };
  int n = 1, c, i, j = 0;
  
  
  if ((scan_type = (int *)malloc(PTHREAD_MAX*sizeof(int))) == NULL)
    { 
      fprintf(stderr, "Error: Couldn't allocate enough memory!\n");
      exit(1); 
    }
    
  
  /*
   * Default each scan is random, and time for waiting for port is 1s
   */
   
  for (i = 0; i < PTHREAD_MAX; i++)
    scan_type[i] = SYN_SCAN;
  
  time_for_port = 1;    
 
  
  
  while ((c = getopt(argc, argv, "i:g:a:p:t:yhsfxnrSFXNUR")) > 0)
    {
      switch (c)
	{
	case 'h'  : { usage(); }
	
	
	case 'i'  : {
	              dev = optarg;
                      break;
                    }

	case 'g'  : {
	              gateway_ip = optarg;
                      break;
                    }

	case 'a'  : {
	              compute_range(optarg, &first_host, &last_host);
    	              ptr = strrchr(optarg, '.');
                      if (ptr == NULL)
                        usage();
                      *(ptr) = '\0';
                      main_part = optarg;
                      arp_discovery(main_part, first_host, last_host);
                      exit(0);
                      break;
                    }

	case 'p'  : {
	              port_range=optarg;
                      break;
                    }

	case 'y'  : {
	              fake_ok = 1;
                      break;
                    }
                      
	case 't'  : {
	              time_for_port = atoi(optarg);
	              break; 
                    }
                    
	case 's'  : { 
                      scan_type[j++] = SYN_SCAN;
                      break;
                    }

	case 'f'  : {
	              scan_type[j++] = FIN_SCAN;
                      break;
                    }

	case 'x'  : {
	              scan_type[j++] = XMAS_SCAN;
	              break;
                    }

	case 'n'  : { 
	              scan_type[j++] = NULL_SCAN;
                      break;
                    }

	case 'r'  : {
	              scan_type[j++] = RAND_SCAN;
                      break;
                    }

	case 'S'  : { 
	              for (n = 0; n < PTHREAD_MAX; n++)
	                scan_type[n] = SYN_SCAN;
                      break;
                    }
                    
        case 'F'  : {
                      for (n = 0; n < PTHREAD_MAX; n++)
                        scan_type[n] = FIN_SCAN;
                      break;
                    }
                    
        case 'X'  : {
                      for (n = 0; n < PTHREAD_MAX; n++)
                        scan_type[n] = XMAS_SCAN;
                      break;
                    }
                    
        case 'N'  : {
                      for (n = 0; n < PTHREAD_MAX; n++)
                        scan_type[n] = NULL_SCAN;
                      break;
                    }
                    
	case 'U'  : { 
	              for (n = 0; n < PTHREAD_MAX; n++)
	                scan_type[n] = UDP_SCAN;
                      break;
                    }

	default   : {
	              usage();
                    }
	}
    }


  if (((argc - optind) == 0))
    usage();
  
  /*
   * service for some signals
   */
  
  signal(SIGINT, serve_polite);
  signal(SIGILL, serve_polite);
  signal(SIGHUP, serve_polite);
  signal(SIGABRT, serve_polite); 
  
  if(dev==NULL)
    if((dev=pcap_lookupdev(NULL))==NULL)
      { 
         fprintf(stderr, "Couldn't fine any interface!\n");
         exit(1);
      }
  
  printf("\t\t----PAPS version 1.0----\n");       
  printf("[X] Using %s \n", dev);
  printf("[X] Target: %s\n", argv[optind]);
  
  if((hostinfo=gethostbyname(argv[optind]))<0)
      { perror("gethostbyname: ");
        exit(1); }
  
  memcpy(&target, hostinfo->h_addr, 4);
  inet_ntop(PF_INET, &target, target_ip, sizeof(target_ip));
  
  pthread_count = list_get(&addr_list);
  if (pthread_count == 0)
    {
      printf("[!] At the begining you should get ip->mac map!\n");
      printf("[!] Launch with -a option\n");
      exit(1);
    }
  
  /*
   * if target is in the same segment, it's our gateway
   */
   
  if(gateway_ip==NULL)
      gateway_ip = target_ip;
  
   
  temp = addr_list;
  while ((temp != NULL) && strcmp(gateway_ip, temp->ip))
      temp = temp->next;
        
  if (temp == NULL)
    {
      printf("[!] Your gateway seems to be dead, try again with new ip->mac map!\n");
      exit(1);
    }
    
  ptr = temp->hw;
  memcpy(gateway, ptr, ETH_ALEN);
  
  
  /*
   * don't spoof gateway, because you don't receive any reponse
   */
  
  list_del(&addr_list, gateway_ip);
  pthread_count--;
  
  
  
  if((arg = (struct pthread_arg *)calloc(pthread_count, sizeof(struct pthread_arg)))==NULL)
      { perror("calloc: ");
        exit(1); }
    
    
  if((ports = (struct port_list *)calloc(pthread_count, sizeof(struct port_list)))==NULL)
      {	perror("calloc: ");
        exit(1); }
        
  
  spread_ports(port_range);
  
  if (j > pthread_count)
    printf("[!] Too many scan types, next time compute how many you really need\n");

  
  temp = addr_list;
  
  for (n = 0; n < pthread_count; n++)
    {
      if((ports[n].state = (int *)calloc(ports[n].count, sizeof(int)))==NULL)
          { perror("calloc ");
            exit(1); }
      
      inet_pton(PF_INET, temp->ip, &arg[n].decoy);
      arg[n].decoy_hw = temp->hw;
      arg[n].target = target;
      arg[n].num = n;
      arg[n].scan_type = scan_type[n];

      if (scan_type[n] == RAND_SCAN)
	{
	  if ((ports[n].type=(int *)calloc(ports[n].count, sizeof(int)))==NULL)
              { perror("calloc: ");
                exit(1); }

	  for (i = 0; i < ports[n].count; i++)
	    ports[n].type[i] = tab[rand() % 4];  
	}
      

      pthread_create(&pthread_id[n], NULL, (void *)scan, (void *)&arg[n]);
      
      if ((temp = temp->next) == NULL)
	temp = addr_list;
    }

  free(scan_type);
  
  for (n = 0; n < pthread_count; n++)
      pthread_join(pthread_id[n], NULL);

  display_results();
  
  return 0;
}


void scan(void *arg)
{
  struct pthread_arg *buf = (struct pthread_arg *)arg;
  
  switch (buf->scan_type)
    { 
      case UDP_SCAN :
          {
              udp_sender(buf->decoy_hw, buf->decoy, buf->target, &ports[buf->num]); 	     
           
              udp_receiver(buf->decoy, buf->target, &ports[buf->num]);
              
              break;
          }

      default :
          {
              tcp_sender(buf->decoy_hw, buf->decoy, buf->target, buf->scan_type, &ports[buf->num]);
                
              tcp_receiver(buf->decoy, buf->target, buf->scan_type, &ports[buf->num]);
          
              break;
          }
    }
}



char *compute_range(char *arg, int *from, int *to)
{
  char *ptr;

  ptr = strrchr(arg, '-');
  if (ptr == NULL)
    {
      usage();
    }
  *(ptr++) = '\0';
  *to = atol(ptr);
  ptr = strrchr(arg, '.');
  if (ptr == NULL)
    {
      usage();
    }
  *from = atoi((++ptr));
  return arg;
}



int spread_ports(char *expr)
{
  char *ptr1, *ptr2;
  int fport, eport;
  int i, j, n; 
  int tmp, r1, r2;


  /*
   * range of ports
   */
   
  ptr1 = expr;

  if ((ptr2 = strchr(expr, '-')) != NULL)
    {
      *(ptr2++) = '\0';

      fport = atoi(ptr1);
      eport = atoi(ptr2);
      
      if(eport-fport<0)
        { 
          fprintf(stderr, "Error: Bad port range\n");
          exit(1);
        }
      
      for(i=0;i<pthread_count;i++)
          if((ports[i].port=(int *)calloc(((eport-fport+1)/pthread_count+1), sizeof(int)))==NULL)
              {	perror("calloc port");
                exit(1); }
      
      
      if(pthread_count > eport-fport+1) pthread_count=eport-fport+1;
      n=0;
      for (i = 0; i <= eport - fport+1; i++)
	{ 
	  ports[n].port[i/pthread_count] = fport + i;
	  ports[n].count++;
	  if(++n==pthread_count) n=0;
        }

     n = eport - fport+1;
    
    }
  
  
  /*
   * list of ports
   */
  

  //getting quantity of ports
  //XXX   
  
  else
    {
      ptr2 = expr;
      i = 1;
      while ((ptr1 = strchr(ptr2, ',')) != NULL)
        {
          ptr2 = ++ptr1;
          i++;
        }

      if (i > 65535)
        {
          i = 65535;
          printf("[!] Too many ports, right?...\n");
        }
      
      if(i<pthread_count) pthread_count=i;

  
      for(j=0;j<pthread_count;j++)
          if((ports[j].port=(int *)calloc(i/pthread_count+1, sizeof(int)))==NULL)
              { perror("calloc: ");
                exit(1); }
              
                                                       
      j=n=0;
  
      ptr2=expr;
      for(j=0;j<i;j++)
        {
          if((ptr1 = strchr(ptr2, ','))==NULL) break;
          *(ptr1++) = '\0';
          ports[n].port[j/pthread_count] = atoi(ptr2);
          ports[n].count++;
          ptr2 = ptr1;
          if(++n==pthread_count) n=0;
        }

      ports[n].port[j/pthread_count] = atoi(ptr2);
      ports[n].count++;
  
      n = i;
   }
  
  j=0; 
  for (i = 0; i <= n; i++)
   { 
      r1 = rand()%pthread_count;
      r2 = rand()%(n/pthread_count);
      tmp = ports[j].port[COMP(i/pthread_count, ports[j].count-1)];
      ports[j].port[COMP(i/pthread_count, ports[j].count-1)] = ports[r1].port[COMP(r2, ports[j].count-1)];
      ports[r1].port[COMP(r2, ports[j].count-1)] = tmp;
      if(++j==pthread_count) j=0;
   }
                                                          
  return 0;
}

void display_results(void)
{
  int i, n;
  int is = 0;
  
  /*
   * Generaly don't write state of closed and opened|filtered ports
   * If you need it, simply uncomment needed pieces of code
   */

  printf("\nPORT\t\tSTATE\n");
  for (i = 0; i < pthread_count; i++)
    {
      for (n = 0; n < ports[i].count; n++)
	{
	  switch((arg[i].scan_type == RAND_SCAN) ? ports[i].type[n] : arg[i].scan_type)
	    {
	       case SYN_SCAN :	{  	
	                                if(ports[i].state[n]==1)
	                                   { printf("%d/tcp\t\topened\n", ports[i].port[n]); 
	                                     is++; }
	                             //   else if(ports[i].state[n]==0)
	                             //      printf("%d/tcp\topened|filtered\n", ports[i].port[n]);
                                        break;  }
               
               case UDP_SCAN :	{
                                        if(ports[i].state[n]==2)
                                           { printf("%d/udp\t\topened\n", ports[i].port[n]);
                                             is++; }	
                                     //   else if(ports[i].state[n]==0)
                                     //      printf("state %d\t%d/udp opened|filtered\n", ports[i].state[n], ports[i].port[n]);
                                        break;  }
               
               default	     :	{    //   if(ports[i].state[n]!=2)
                                     //      printf("%d/tcp\topened|filtered\n", ports[i].port[n]);  
                                        break;  }
	    }                             
        }
    }
 if(!is)
   { printf("[!] Unfortunately there are no opened ports in target machine\n");
     printf("[!] Try again, maby some problems on the wired\n"); }
 printf("\n");    
}


void serve_polite(int sig)
{
  display_results();
  printf("+++Exiting on signal %d+++\n", sig);
  exit(1);
} 


void usage(void)
{
  fprintf(stderr, "paps: usage [scan_type] [options] host\n");
  fprintf(stderr, "\t-S -s \t\t syn scan\n");
  fprintf(stderr, "\t-F -f \t\t fin scan\n");
  fprintf(stderr, "\t-X -x \t\t Xmas scan\n");
  fprintf(stderr, "\t-N -n \t\t NULL scan\n");
  fprintf(stderr, "\t-R -r \t\t random scan (each port scan by randomly method)\n");
  fprintf(stderr, "\t\t\t this is default method\n");
  fprintf(stderr, "\t-U  \t\t udp scan\n");
  fprintf(stderr, "\t-a <host range>  make ip->mac map\n");
  fprintf(stderr, "\t-p <ports> \t ports you wanna scan\n");
  fprintf(stderr, "*\t-g <ip> \t gateway ip\n");
  fprintf(stderr, "*\t-t <val>\t time for waiting for each port, default 1 sec\n");
  fprintf(stderr, "\t-y \t\t i wanna fake mac and ip during sending arp requests\n");
  fprintf(stderr, "\t-i <dev> \t interface you wanna use\n");
  fprintf(stderr, "\t-h \t\t display me\n");
  exit(1);
}

